#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  char myname[MPI_MAX_PROCESSOR_NAME]; 
  int size, rank, rlen, from, next;

  MPI_Init (&argc, &argv);

  MPI_Comm_size (MPI_COMM_WORLD, &size);
  
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);

  MPI_Get_processor_name (myname, &rlen);

  fprintf (stdout, "I am proces %3d of %3d my name is %s (%s)\n", 
    rank, size, myname, argv[0]);

  fflush(stdout);

  if (size > 1) {
    int sval, rval;
    MPI_Status status;

    next = (rank + 1) % size;
    from = (rank + size - 1) % size;

    sval = rank;
    
    MPI_Sendrecv(&sval, 1, MPI_INT, next, 10, &rval, 1, 
        MPI_INT, from, 10, MPI_COMM_WORLD, &status);
    
    fprintf (stdout, "I am rank %d and I received %d\n", rank, rval);
  }

  MPI_Finalize ();
 
  return 0;
} 
